# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class URI(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, uri_id: str=None, user_id: int=None, real_uri: str=None, short_uri: str=None, activated: bool=None, reachable: bool=None, safe: bool=None):  # noqa: E501
        """URI - a model defined in Swagger

        :param uri_id: The uri_id of this URI.  # noqa: E501
        :type uri_id: str
        :param user_id: The user_id of this URI.  # noqa: E501
        :type user_id: int
        :param real_uri: The real_uri of this URI.  # noqa: E501
        :type real_uri: str
        :param short_uri: The short_uri of this URI.  # noqa: E501
        :type short_uri: str
        :param activated: The activated of this URI.  # noqa: E501
        :type activated: bool
        :param reachable: The reachable of this URI.  # noqa: E501
        :type reachable: bool
        :param safe: The safe of this URI.  # noqa: E501
        :type safe: bool
        """
        self.swagger_types = {
            'uri_id': str,
            'user_id': int,
            'real_uri': str,
            'short_uri': str,
            'activated': bool,
            'reachable': bool,
            'safe': bool
        }

        self.attribute_map = {
            'uri_id': 'uriId',
            'user_id': 'userId',
            'real_uri': 'realURI',
            'short_uri': 'shortURI',
            'activated': 'activated',
            'reachable': 'reachable',
            'safe': 'safe'
        }

        self._uri_id = uri_id
        self._user_id = user_id
        self._real_uri = real_uri
        self._short_uri = short_uri
        self._activated = activated
        self._reachable = reachable
        self._safe = safe

    @classmethod
    def from_dict(cls, dikt) -> 'URI':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The URI of this URI.  # noqa: E501
        :rtype: URI
        """
        return util.deserialize_model(dikt, cls)

    @property
    def uri_id(self) -> str:
        """Gets the uri_id of this URI.


        :return: The uri_id of this URI.
        :rtype: str
        """
        return self._uri_id

    @uri_id.setter
    def uri_id(self, uri_id: str):
        """Sets the uri_id of this URI.


        :param uri_id: The uri_id of this URI.
        :type uri_id: str
        """

        self._uri_id = uri_id

    @property
    def user_id(self) -> int:
        """Gets the user_id of this URI.


        :return: The user_id of this URI.
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id: int):
        """Sets the user_id of this URI.


        :param user_id: The user_id of this URI.
        :type user_id: int
        """

        self._user_id = user_id

    @property
    def real_uri(self) -> str:
        """Gets the real_uri of this URI.


        :return: The real_uri of this URI.
        :rtype: str
        """
        return self._real_uri

    @real_uri.setter
    def real_uri(self, real_uri: str):
        """Sets the real_uri of this URI.


        :param real_uri: The real_uri of this URI.
        :type real_uri: str
        """

        self._real_uri = real_uri

    @property
    def short_uri(self) -> str:
        """Gets the short_uri of this URI.


        :return: The short_uri of this URI.
        :rtype: str
        """
        return self._short_uri

    @short_uri.setter
    def short_uri(self, short_uri: str):
        """Sets the short_uri of this URI.


        :param short_uri: The short_uri of this URI.
        :type short_uri: str
        """

        self._short_uri = short_uri

    @property
    def activated(self) -> bool:
        """Gets the activated of this URI.


        :return: The activated of this URI.
        :rtype: bool
        """
        return self._activated

    @activated.setter
    def activated(self, activated: bool):
        """Sets the activated of this URI.


        :param activated: The activated of this URI.
        :type activated: bool
        """

        self._activated = activated

    @property
    def reachable(self) -> bool:
        """Gets the reachable of this URI.


        :return: The reachable of this URI.
        :rtype: bool
        """
        return self._reachable

    @reachable.setter
    def reachable(self, reachable: bool):
        """Sets the reachable of this URI.


        :param reachable: The reachable of this URI.
        :type reachable: bool
        """

        self._reachable = reachable

    @property
    def safe(self) -> bool:
        """Gets the safe of this URI.


        :return: The safe of this URI.
        :rtype: bool
        """
        return self._safe

    @safe.setter
    def safe(self, safe: bool):
        """Sets the safe of this URI.


        :param safe: The safe of this URI.
        :type safe: bool
        """

        self._safe = safe
